/************************************************************************
 *
 *			ob|rdqud
 *
 *				: hr`l֘A`
 *		t@C	: pcsdb.h
 *		쐬		: s.aizawa
 *
 ************************************************************************/

#define	BLOCK_SIZE	512				// CfbNXt@C̃ubNTCY
#define	MAX_IDX		40				// ɃI[vłCfbNXt@C
#define	EXT_FIELD	0x1521			// gtB[h
#define	FLAG_FREEBLOCK	0x0414		// CfbNXt[ubNLtO
#define	BIN_BLOCK_SIZE	1024		// oCit@CubNTCY
#define	BIN_DATA_SIZE	(BIN_BLOCK_SIZE - 4)	// oCif[^TCY

// CfbNXimcwjt@C̃wb_
typedef	struct	_IDX_H	{
	LONG	root;				// [g̃ubNmD
	ULONG	nBlock;				// ubN
	SHORT	lBlock;				// ubN
	SHORT	reserved1;			// \P
	SHORT	lKey;				// L[̒
	SHORT	order;				// 
	SHORT	type;				// f[^
	SHORT	lRec;				// PR[h̒
	SHORT	reserved2;			// \Q
	CHAR	reserved3;			// \R
	CHAR	uniq;				// j[NtO
	CHAR	index[100];			// CfbNX\
	CHAR	work[382];			// [NGA
	SHORT	fFreeBlock;			// t[ubNLtO
	ULONG	nFreeBlock;			// t[ubN
} IDX_H, *PIDX_H;

// CfbNXubN
typedef	struct	_IDX_B	{
	LONG	bno;				// ubNmD
	SHORT	cp;					// Jg|C^
	struct	_IDX_B	*fwp;		// `FC|C^
	struct	_IDX_B	*bwp;		// `FC|C^
	CHAR	block[0];			// ubN
} IDX_B, *PIDX_B;

// CfbNXt@CǗ
typedef	struct	_IDX_F	{
	CHAR	fileName[256];		// t@C
	int		fh;					// t@Cnh
	PIDX_H	ihp;				// wb_|C^
	SHORT	updateFlag;			// XVtO
	SHORT	exFlag;				// gCfbNXtO
	SHORT	lBlock;				// ubN
	struct	_IDX	*ip;		// IDX|C^
	struct	_IDX_F	*chain;		// IDX_F`FC
} IDX_F, *PIDX_F;

// CfbNXǗ
typedef	struct	_IDX	{
	PIDX_B	bp;					// JgubN|C^
	PIDX_B	top;				// ubN|C^
	PIDX_B	bottom;				// ubN|C^
	CHAR	*keyp;				// L[|C^
	struct	_IDX_F	*ifp;		// IDX_F|C^
	struct	_IDX	*chain;		// IDX`FC
#ifdef	MULTI_OPEN
	int		fh;					// NDX t@Cnh
#endif
} IDX, *PIDX;

// oCit@C̃wb_
typedef	struct	_BIN_H	{
	LONG	nUsedBlock;			// gpubN
	LONG	freeBlock;			// 󂫃ubNԍ
	CHAR	reserved[BIN_BLOCK_SIZE - 8];
} BIN_H, *PBIN_H;

// oCit@CǗ
typedef	struct	_BIN	{
	CHAR	fileName[256];		// t@C
	int		fh;					// t@Cnh
	PBIN_H	bhp;				// wb_ւ̃|C^
	LONG	dataSize;			// f[^TCY
	LONG	dataSize2;			// ㏑Õf[^TCY
	LONG	bno;				// JgubNԍ
	LONG	remain;				// ubNobt@cf[^TCY
	LONG	offset;				// ubNobt@ItZbg
	LONG	bnoTop;				// 擪̃ubNԍ
	LONG	bnoNext;			// ̃ubNԍ
	CHAR	buf[BIN_BLOCK_SIZE];	// ubNobt@
	BOOL	updateBlockFlag;	// ubNXVtO
	BOOL	updateSizeFlag;		// TCYXVtO
	BOOL	updateHeaderFlag;	// wb_XVtO
} BIN, *PBIN;

// oCif[^ǂݍ݊Ǘ
typedef	struct	_BIN_R	{
	LONG	dataSize;			// cf[^TCY
	LONG	bno;				// JgubNԍ
	LONG	remain;				// ubNobt@cf[^TCY
	LONG	offset;				// ubNobt@ItZbg
	CHAR	buf[BIN_BLOCK_SIZE];	// ubNobt@
} BIN_R, *PBIN_R;

// f[^icaejt@C̃wb_
typedef	struct	_DBF_H	{
	CHAR	flag;				// f[^x[XeLXgt@CۗLtO
	CHAR	date[3];			// ŏIXV
	LONG	nRec;				// R[h
	SHORT	lHeader;			// wb_̒
	SHORT	lRec;				// PR[h̒
	SHORT	extField;			// gtB[h
	USHORT	scramble;			// ÍL[
	CHAR	password[8];		// pX[h
	CHAR	reserve[8];			// VXe\̈
} DBF_H, *PDBF_H;

// tB[h
typedef	struct	_FIELD	{
	CHAR	name[11];			// tB[h
	CHAR	type;				// tB[h`
	SHORT	offset;				// tB[hItZbg
	SHORT	lField2;			// gtB[h
	CHAR	lField;				// tB[h
	CHAR	lDec;				// ʌ
	CHAR	reserve1[5];		// VXe\̈
	CHAR	flag;				// SET FIELDS ON/OFF ̐ݒtO
	CHAR	reserve2[8];		// VXe\̈
} FIELD, *PFIELD;

// R[hbN
typedef	struct	_DBLOCK	{
	struct	_DB	*dbp;			// R[hbN dbp
	LONG	rno;				// bNR[hԍ
	struct	_DBLOCK	*chain;		// `FC
} DBLOCK, *PDBLOCK;

// f[^t@CǗ
typedef	struct	_DBF	{
	CHAR	fileName[256];		// t@C
	int		fh;					// t@Cnh
	PDBF_H	dhp;				// wb_ւ̃|C^
	PFIELD	flp;				// tB[hւ̃|C^
	SHORT	nField;				// tB[h
	SHORT	updateFlag;			// XVtO
	LONG	updateCount;		// XVJE^
	SHORT	adjustFlag;			// R[htO
	int		readLockCount;		// t@Cǂݍ݃bNJEg
	int		writeLockCount;		// t@C݃bNJEg
	PDBLOCK	rdlp;				// R[hǂݍ݃bN
	PDBLOCK	wdlp;				// R[h݃bN
	PBIN	bfp;				// oCit@C
	SHORT	lRec;				// R[hioCitB[hj
	CRITICALSECTION	csDBF;		// DBF N`JZNV
	struct	_DB	*dbp;			// DB|C^
	struct	_DBF	*chain;		// DBF`FC
} DBF, *PDBF;

// f[^x[XǗ
typedef	struct	_DB	{
	PDBF	dp;					// f[^t@C
	PBIN_R	brp;				// oCif[^ǂݍݏ
	PIDX	ip[MAX_IDX+1];		// CfbNXt@C
	int		master;				// }X^[CfbNX
	int		nIdx;				// CfbNXt@C
	LONG	rno;				// JgR[hmD
	SHORT	bof;				// anetO
	SHORT	eof;				// dnetO
	SHORT	setDeleted;			// 폜R[htO
	CHAR	*filter;			// tB^
	HPSTR	select;				// IR[htO
	LONG	selectRec;			// ĨR[h
	SHORT	*readField;			// ǂݍ݃tB[h
	SHORT	readSize;			// ǂݍ݃TCY
	CHAR	*rbp;				// R[hobt@
	CHAR	*rbp2;				// R[hobt@Q
	LONG	updateCount;		// XVJE^
	int		readLockCount;		// t@Cǂݍ݃bNJEg
	int		writeLockCount;		// t@C݃bNJEg
	SHORT	permission;			// ANZX[h
	struct	_DB	*chain;			// `FC|C^
#ifdef	MULTI_OPEN
	int		fh;					// DBF t@Cnh
#endif
} DB, *PDB;

// ֐`
extern	SHORT	DBOpen(CHAR *, PDB *, SHORT);
extern	SHORT	DBCreate(CHAR *, PDBF_I, SHORT, PDB *, SHORT);
extern	SHORT	DBClose(PDB);
extern	SHORT	DBFlush(PDB);
extern	SHORT	DBIndex(PDB, CHAR *, SHORT *);
extern	SHORT	DBIdxCreate(PDB, CHAR *, CHAR *, SHORT, SHORT *);
extern	SHORT	DBChgIdx(PDB, SHORT);
extern	SHORT	DBSearch(PDB, CHAR *, SHORT);
extern	SHORT	DBSearch2(PDB, CHAR *, SHORT, SHORT *);
extern	SHORT	DBSearchLock(PDB, CHAR *, SHORT, LONG *);
extern	SHORT	DBCount(PDB, CHAR *, SHORT, LONG *);
extern	SHORT	DBStore(PDB, CHAR *);
extern	SHORT	DBStoreUniq(PDB, CHAR *);
extern	SHORT	DBUpdate(PDB, CHAR *);
extern	SHORT	DBUpdateKey(PDB, CHAR *, SHORT, CHAR *);
extern	SHORT	DBDelete(PDB);
extern	SHORT	DBDelete2(PDB);
extern	SHORT	DBDelete3(PDB);
extern	SHORT	DBDeleteKey(PDB, CHAR *, SHORT, SHORT);
extern	SHORT	DBRecall(PDB);
extern	SHORT	DBTop(PDB);
extern	SHORT	DBBottom(PDB);
extern	SHORT	DBSet(PDB, LONG);
extern	SHORT	DBSkip(PDB, LONG);
extern	SHORT	DBReindex(PDB);
extern	SHORT	DBPack(PDB);
extern	SHORT	DBRead(PDB, CHAR *);
extern	SHORT	DBReadNext(PDB, SHORT, CHAR *, SHORT *);
extern	SHORT	DBReadBack(PDB, SHORT, CHAR *, SHORT *);
extern	SHORT	DBReadKey(PDB, CHAR *, SHORT, CHAR *, SHORT, SHORT *);
extern	SHORT	DBReadBinary(PDB, CHAR *, HPSTR, LONG, LONG *);
extern	SHORT	DBWriteBinary(PDB, CHAR *, HPSTR, LONG);
extern	SHORT	DBGetBinarySize(PDB, CHAR *, LONG *);
extern	SHORT	DBClrRecord(PDB);
extern	SHORT	DBGetRecord(PDB);
extern	SHORT	DBGetField(PDB, CHAR *, VOID *, SHORT *, SHORT *);
extern	SHORT	DBSetField(PDB, CHAR *, VOID *);
extern	SHORT	DBAddRecord(PDB);
extern	SHORT	DBUpdRecord(PDB);
extern	SHORT	DBCopy(PDB, PDB);
extern	SHORT	DBCheckDeleted(PDB, SHORT *);
extern	SHORT	DBSetFilter(PDB, CHAR *);
extern	SHORT	DBSelect(PDB, CHAR *, LONG *);
extern	SHORT	DBSetDeleted(PDB, SHORT);
extern	SHORT	DBLRecNo(PDB, LONG *);
extern	SHORT	DBLRecCount(PDB, LONG *);
extern	SHORT	DBLSet(PDB, LONG);
extern	SHORT	DBZip(PDB);
extern	SHORT	DBCheckUpdate(PDB, SHORT *);
extern	SHORT	DBLock(PDB, SHORT);
extern	SHORT	DBUnlock(PDB, SHORT);
extern	SHORT	DBRecCount(PDB, LONG *);
extern	SHORT	DBBof(PDB, SHORT *);
extern	SHORT	DBDbf(PDB, CHAR *);
extern	SHORT	DBEof(PDB, SHORT *);
extern	SHORT	DBNField(PDB, SHORT *);
extern	SHORT	DBField(PDB, SHORT, PDBF_I);
extern	SHORT	DBNdx(PDB, SHORT, CHAR *);
extern	SHORT	DBRecNo(PDB, LONG *);
extern	SHORT	DBRecSize(PDB, SHORT *);
extern	SHORT	DBSetReadField(PDB, CHAR *, SHORT *);
extern	SHORT	DBSetScramble(PDB);
extern	SHORT	DBSetPassword(PDB, CHAR *);
extern	SHORT	DBUpdateEx(PDB, LONG, CHAR *);
extern	SHORT	DBDeleteEx(PDB, LONG);
extern	SHORT	DBRecallEx(PDB, LONG);
extern	SHORT	DBDelete2Ex(PDB, LONG);
extern	SHORT	DBLockEx(PDB, LONG, SHORT);
extern	SHORT	DBPackIndex(CHAR *);

// CfbNX̃L[
#define	KEY_TYPE_C	0	// ^
#define	KEY_TYPE_N	1	// ^
#define	KEY_TYPE_I	2	// ^
